/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: adpcm.c
* ߲		: IAR EWAAVR 3.10C
* 			: $Revision: 1.4 $
* t			: $Date: Monday, November 15, 2004 12:53:58 UTC $
* XV		: $Author: raapeland $
*
* xҰ		: avr@atmel.com
*
* x޲	: ̗ATmega128pɏĂ܂B̧ѳ͍Œ4K޲(+
*				  ްp̏[ȋ)ׯ ؂ǂꂩAVRź߲ق
*				  ׂłB
*
* pLq		: AVR336: ADPCM
*
* 			: ADPCMٰ
*
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "adpcm.h"
#include "ioavr.h"
#include "inavr.h"

// **************************************************************************
// Q7\L

static short	*_dqlntab;

static short	_dqlntab2[2] = {117, 364};
static short	_dqlntab3[4] = {-2048, 135, 273, 373};
static short	_dqlntab4[8] = {-2048, 4, 135, 213, 273, 323, 373, 425};
static short	_dqlntab5[16] = {-2048, -66, 28, 104, 169, 224, 274, 318,
								 358, 395, 429, 459, 488, 514, 539, 566};

// **************************************************************************
// Q4\L

static short	*_witab;

static short	_witab2[2] = {-22, 439};
static short	_witab3[4] = {-4, 30, 137, 582};
static short	_witab4[8] = {-12, 18, 41, 64, 112, 198, 355, 1122};
static short	_witab5[16] = {14, 14, 24, 39, 40, 41, 58, 100,
							   141, 179, 219, 280, 358, 440, 529, 696};

// **************************************************************************
// Q9\L

static short	*_fitab;

static short	_fitab2[2] = {0, 0xE00};
static short	_fitab3[4] = {0, 0x200, 0x400, 0xE00};
static short	_fitab4[8] = {0, 0, 0, 0x200, 0x200, 0x200, 0x600, 0xE00};
static short	_fitab5[16] = {0, 0, 0, 0, 0, 0x200, 0x200, 0x200,
							   0x200, 0x200, 0x400, 0x600, 0x800, 0xA00, 0xC00, 0xC00};

// **************************************************************************

extern char __hugeflash *packed;	// ADPCMlߍݘ^ւ̈ʒuwq
extern signed int     sample;
extern int            buffer[];
extern unsigned char   da_ind;
extern unsigned char   decoder_ind;

/*
 * ADPCMԏ(ITU-T G.726Œ`ꂽl)
 */

void initialize_adpcm(adpcm_state state){

	int n;

	state->yl = 34816;
	state->yu = 544;
	state->dms = 0;
	state->dml = 0;
	state->ap = 0;

	for (n = 0; n < 2; n++) {
		state->a[n] = 0;
		state->pk[n] = 0;
//		state->sr[n] = 32;		// 4ޯĎw6ޯĉłfp32=1.5~2^0
		state->sr[n] = 2;
	}

	for (n = 0; n < 6; n++) {
		state->b[n] = 0;
		state->dq[n] = 32;
		state->dq[n] = 2;
	}

	state->td = 0;

	switch(BITS){
		case 2:
			_dqlntab = _dqlntab2;
			_witab = _witab2;
			_fitab = _fitab2;
			break;
		case 3:
			_dqlntab = _dqlntab3;
			_witab = _witab3;
			_fitab = _fitab3;
			break;
		case 4:
			_dqlntab = _dqlntab4;
			_witab = _witab4;
			_fitab = _fitab4;
			break;
		case 5:
			_dqlntab = _dqlntab5;
			_witab = _witab5;
			_fitab = _fitab5;
			break;
		default:
			_dqlntab = _dqlntab4;
			_witab = _witab4;
			_fitab = _fitab4;
			break;
	}
}

/*
 * ̂߂ɍPWMœ悤/1\ݒ
 */

void initialize_pwm(void){

	TCCR1A = (1<<COM1A1) | (1<<WGM11) | (0<<WGM10);							// rvOCR1A/TOPŐݒA9ޯčPWMw
	TCCR1B = (0<<WGM13) | (1<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10);	// 9ޯčPWM(TOPl=$01FF)AOuȂŎn
	// 16MHz9ޯ(܂8MHz8ޯ)31.25kHzŖ8kHz4{(PWMg͍Œ̎g4{łׂłB)
	DDRB |= (1<<DDB5);														// OCR1A(PB5)o͐ݒ
	TCCR3B = (1<<WGM32) | (0<<CS12) | (0<<CS11) | (1<<CS10);				// T/C3CTCw
	OCR3A = 0x1FF * 4;														// PWM~4(1̎)(7.8125kHz)rw
	TCNT3 = 0;																// /3
	ETIMSK |= (1<<OCIE3A);													// /3rAv荞݋
}

/*
 * ΐdql𒼐̈ɕϊdq(15ޯsm)Ԃ܂B
 */
 
#pragma inline
int antilog(int sign, int dql){

	short dex;		// w
	short dmn;		// 
	short dqmag;	// {

	if (dql < 0) {
		return ((sign) ? -1 : 0);
	} else {
		dex = (dql >> 7) & 15;						// w(4ޯ)
		dmn = dql & 127;							// (7+1ޯ)
		dmn = 128 + dmn;
		dqmag = ((long)dmn << 7) >> (14 - dex);
		return (sign ? -dqmag : dqmag);
	}
}

/*
 * K\WabXV
 */

short update_pred_coeff(int dq,				// ʎqꂽ\
						int sr,				// č\ꂽM
						int dqsez,			// 2ɗ\̍
						char tr,			// JڐML
						char pk0,
                        adpcm_state state){

	short	a2p;
	short	a1ul;
	char	pks1;
	char	pks2;
	short	fa1;

	if (tr == 1) {									// JڐMȂASW=0
		state->a[0] = 0;
		state->a[1] = 0;
		state->b[0] = 0;
		state->b[1] = 0;
		state->b[2] = 0;
		state->b[3] = 0;
		state->b[4] = 0;
		state->b[5] = 0;
		a2p = 0;
	} else {										// JڂȂŁA
		pks1 = pk0 ^ state->pk[0];
		pks2 = pk0 ^ state->pk[1];

		a2p = state->a[1] - (state->a[1] >> 7);		// a2XV
		if (dqsez != 0) {
			fa1 = (pks1) ? state->a[0] : -state->a[0];
			if (fa1 < -8191)						// a[0]<-0.5?
		a2p -= 0x100;
			else if (fa1 > 8191)					// a[0]>0.5?
				a2p += 0xFF;
			else
		a2p += fa1 >> 5;

		if (pks2) 
			if (a2p <= -12160)
				a2p = -12288;   
			else if (a2p >= 12416)
				a2p = 12288;
			else
				a2p -= 0x80;
		else if (a2p <= -12416)
			a2p = -12288;
		else if (a2p >= 12160)
			a2p = 12288;
		else
			a2p += 0x80;
		}
		state->a[1] = a2p;

		state->a[0] -= state->a[0] >> 8;			// a1XV
		if (dqsez != 0)
			if (pks1 == 0)
				state->a[0] += 192;
			else
				state->a[0] -= 192;

		// a1
		a1ul = 15360 - a2p;
		if (state->a[0] < -a1ul)
			state->a[0] = -a1ul;
		else if (state->a[0] > a1ul)
			state->a[0] = a1ul;

		// K\bWXV
		if (BITS == 5){							// 5ޯADPCMŁA
			state->b[0] -= state->b[0] >> 9;
			state->b[1] -= state->b[1] >> 9;
			state->b[2] -= state->b[2] >> 9;
			state->b[3] -= state->b[3] >> 9;
			state->b[4] -= state->b[4] >> 9;
			state->b[5] -= state->b[5] >> 9;
		}else{									// 2,3,4ޯADPCMŁA
			state->b[0] -= state->b[0] >> 8;
			state->b[1] -= state->b[1] >> 8;
			state->b[2] -= state->b[2] >> 8;
			state->b[3] -= state->b[3] >> 8;
			state->b[4] -= state->b[4] >> 8;
			state->b[5] -= state->b[5] >> 8;
		}

		if ((dq ^ state->dq[0]) >= 0)
			state->b[0] += 128;
		else
			state->b[0] -= 128;

		if ((dq ^ state->dq[1]) >= 0)
			state->b[1] += 128;
		else
			state->b[1] -= 128;

		if ((dq ^ state->dq[2]) >= 0)
			state->b[2] += 128;
		else
			state->b[2] -= 128;

		if ((dq ^ state->dq[3]) >= 0)
			state->b[3] += 128;
		else
			state->b[3] -= 128;

		if ((dq ^ state->dq[4]) >= 0)
			state->b[4] += 128;
		else
			state->b[4] -= 128;

		if ((dq ^ state->dq[5]) >= 0)
			state->b[5] += 128;
		else
			state->b[5] -= 128;
	}

	state->dq[5] = state->dq[4];
	state->dq[4] = state->dq[3];
	state->dq[3] = state->dq[2];
	state->dq[2] = state->dq[1];
	state->dq[1] = state->dq[0];
	state->dq[0] = dq;

	state->sr[1] = state->sr[0];
	state->sr[0] = sr;

	return a2p;
}

/*
 * K\AM\sesezvZ
 *
 */

#pragma inline
short predictor(short *sez, adpcm_state state){

	long sezi;
	long tmp;

	// Q16~Q032ޯQ16
	tmp = (long)state->b[0] * (long)state->dq[0];
	sezi = tmp;
	tmp = (long)state->b[1] * (long)state->dq[1];
	sezi += tmp;
	tmp = (long)state->b[2]  * (long)state->dq[2];
	sezi += tmp;
	tmp = (long)state->b[3]  * (long)state->dq[3];
	sezi += tmp;
	tmp = (long)state->b[4]  * (long)state->dq[4];
	sezi += tmp;
	tmp = (long)state->b[5]  * (long)state->dq[5];
	sezi += tmp;
	*sez = sezi >> 18;
	tmp = (long)state->a[0] * (long)state->sr[0];
	sezi += tmp;
	tmp = (long)state->a[1] * (long)state->sr[1];
	sezi += tmp;
	sezi = sezi >> 18;
	return (sezi);
}

/*
 * ADPCMMi𕜍A14ޯĒPCMMԂ܂B
 */

int decode(char i, adpcm_state state){

	short se, sez;
	short y;
	short sr;
	short dq;
	short dql;
	short dqsez;
	char sign;
	char tr;
	char pk0;
	int dif;
	int al;
	long tmp;
	int ylfrac;
	long ylint;
	int mag;
	int dqthr;
	int thr1, thr2;
	static short a2p = 0;

	/* K\ */
	se = predictor(&sez, state);

	/* ړxW */
	if (state->ap >= 256)
		y = state->yu;
	else {
		y = (state->yl >> 6);
		dif = state->yu - y;
		al = state->ap >> 2;

		if (dif > 0)
			y += ((long)((long)dif * (long)al)) >> 6;
		else if (dif < 0)
			y += ((long)((long)dif * (long)al + 0x3f)) >> 6;
	}

	/* MdqvZ */
	sign = i & (1<<(BITS-1));		// ADPCM𕄍Ƒ傫ɕ
	if(i>=(1<<(BITS-1)))
		i = ((1<<BITS)-1)-i;

	dql = _dqlntab[i] + (y >> 2);
	dq = antilog(sign, dql);		// dq:15ޯtc

	sr = se + dq;					// č\MvZ
	dqsez = dq + sez;				// ɗ\
	pk0 = (dqsez < 0) ? 1 : 0;

	/* Jڌo */
	if (state->td == 0){			// a2(k-1)-0.71875ȂAtd(k-1)=0
		tr = 0;
	}else{
		mag = abs(dq);
		ylint = state->yl >> 15;
		ylfrac = (state->yl >> 10) & 0x1F;
		thr1 = (32 + ylfrac) << ylint;
		thr2 = (ylint > 9) ? 31 << 10 : thr1;
		dqthr = (thr2 + (thr2 >> 1)) >> 1;
		if (mag <= dqthr)
			tr = 0;
		else
			tr = 1;
	}

	/* ړxWiKʍXV */
	tmp = ((long)_witab[i]) << 5;
	state->yu = y + ((tmp - y) >> 5);

	if (state->yu < 544)				// yu
		state->yu = 544;				// 1.06(544 Q9)<yu<10.00(5120 Q9)
	else if (state->yu > 5120)
		state->yu = 5120;

	state->yl = update_yl(state->yl, state->yu);

	/* K\WXV */
	a2p = update_pred_coeff(dq, sr, dqsez, tr, pk0, state);

	state->pk[1] = state->pk[0];
	state->pk[0] = pk0;

	/* o */
	if (tr == 1)
		state->td = 0;
	else if (a2p < -11776)
		state->td = 1;
	else
		state->td = 0;

	/* KxҰXV */
	state->dms += (_fitab[i] - state->dms) >> 5;
	state->dml += (((_fitab[i] << 2) - state->dml) >> 7);	// Q11ɑ΂fi搔2^-7Z
	if (tr == 1)											// JڗLŁA
		state->ap = 256;									// ap = 1;
	else if (y < 1536)										// y<3( )ŁA
		state->ap += (0x200 - state->ap) >> 4;				// ap=(1-2^-4)ap+2^-3
	// tone?
	else if (state->td == 1)								// oŁA
		state->ap += (0x200 - state->ap) >> 4;
	else if (abs((state->dms << 2) - state->dml) >= (state->dml >> 3))	// i̕ς̑傫}ɕωȂA
//else	if (abs(state->dms - (state->dml >> 2)) >= (state->dml >> 1))
		state->ap += (0x200 - state->ap) >> 4;				// dms Q12, dml Q14
	else
		state->ap += (-state->ap) >> 4;

	if(abs(sr) > 8192)
		sr = dq + se - 1;

	return sr;
}

/*
 * ׯ ؂1ADPCM(2,3,4܂5ޯ)擾
 * ^IEND_OF_DATAԂ܂B^INPUTSIZEłB
 */

unsigned char get_code(void){

	static unsigned int in_buffer = 0;
	static char in_bits = 0;
	static long buf_offset = 0;
	unsigned char in_byte;
	unsigned char code;

	if (in_bits < BITS) {
		in_byte = *(packed + buf_offset++);
		if (buf_offset >= INPUTSIZE){
			buf_offset = 0;
			in_buffer = 0;
			in_bits = 0;
			return END_OF_DATA;
		}
		in_buffer |= (in_byte << in_bits);
		in_bits += 8;
	}
	code = in_buffer & ((1 << BITS) - 1);
	in_buffer >>= BITS;
	in_bits -= BITS;
	return code;
}

/*
 * /3rAv荞ݏٰ݁AOCR1Aڼ޽XV܂B
 */

#pragma vector = TIMER3_COMPA_vect
__interrupt void TIMER3_COMPA(void)
{
	PORTB &= 0xFB;
	OCR1A = buffer[da_ind++] + 256;
	if(da_ind >= BUFFER_SIZE)
		da_ind = 0;

	if(da_ind == decoder_ind){		// 肷ĊɏՕɂȂȂA
//		while(1);					// s܂?
//		da_ind--;
	}
	PORTB |= 0x4;
}
